
Redmine - Defect #18174

Rails-4.1 branch merge into trunk (r13482) reverts trunk commits

2014-10-24 05:39 - Mischa The Evil

Status: Closed Start date:  

Priority: High Due date:  

Assignee: Jean-Philippe Lang % Done: 0%

Category:  Estimated time: 0.00 hour

Target version:    

Resolution: Fixed Affected version:  

Description

The merge of the rails-4.1 branch back into trunk contains errors and as such is reverting trunk commits. This is caused by the fact

that the branch was not properly rebased in r13443. During the merge commits on trunk were reverted. This is something I was

already expecting to happen. That is why I reported and patched (finished the rebase) this already in #18134 (under 2.1).

I'm still looking into this right now, but wanted to report this quickly...

First inspection: patch 

http://www.redmine.org/attachments/12519/5.%20merge-missing-in-41-from-trunk_to_rails-4.1_at_r13451.patch (attached to #18134

) which was originally made to apply to rails-4.1 branch, seems to include all reverted commit's changes and should instead now be

applied to trunk.

Assigned to Toshi because you're trying to fix it currently.

Related issues:

Related to Redmine - Patch #18134: Issues with svn:mergeinfo property values ... New

Related to Redmine - Feature #14534: Upgrade to Rails 4.2 Closed

Associated revisions

Revision 13504 - 2014-10-24 20:41 - Jean-Philippe Lang

Restores commits reverted when rails-4.1 branch was merged (#18174).

Patch by Mischa The Evil.

History

#1 - 2014-10-24 05:41 - Mischa The Evil

- Related to Patch #18134: Issues with svn:mergeinfo property values and r13443 rails-4.1 rebase. added

#2 - 2014-10-24 05:44 - Mischa The Evil

To be clear: I'm inspecting the diffs at the moment and will report back when I'm done...

#3 - 2014-10-24 08:31 - Mischa The Evil

- File rm18174-reintegrate_commits_on_trunk_reverted_by_r13482_merge-trunk_r13503.patch added

- Status changed from New to Confirmed

- Assignee deleted (Toshi MARUYAMA)

Ok, done. I'll give a summary of what happened:

1. r13232, source:/sandbox/rails-4.1 branch created from source:/trunk@13231

2. commits on the rails-4.1 branch are made, along with further changes to the trunk (for 2.6.x) [also some merge and backport commits, but that's

not relevant here]

3. r13443, rails-4.1 branch is rebased from trunk at r13439

4. r13482, rails-4.1 branch is merged into trunk

It went wrong in step 3. This is a rebase from trunk at r13439, but in fact it is a rebase from trunk r13333 upto r13439. Since there are commits made

on trunk between r13232 and r13333 which were not yet included on the rails-4.1 branch, these changes are reverted in the final merge of the

rails-4.1 branch into trunk with r13482. Basically, the branch was not up-to-date with the trunk during the merge.

I reported this issue (while the branch wasn't merged yet) in #18134 (under point 2.1), and provided a patch which completed the rebase to include all

commits. This patch was made against the rails-4.1 branch in order to bring it up-to-date completely with trunk (for easy merging in the end...;). The

patch couldn't be integrated before the merge already happened...
In retrospect I should have reported the above mentioned issue separate from the merge tracking info issues, which could have prevented this issue

from arising completely...

Nevertheless, back to the issue. The respective commits are:

Commit Status:

r13284 changes not reverted (locales)

r13285 changes reverted, but reimplemented already in r13502

r13287 changes reverted, to-be-fixed

r13299 changes not reverted (locales)

r13303 changes reverted, to-be-fixed

r13322 changes reverted, to-be-fixed

r13323 changes reverted, to-be-fixed

r13324 changes reverted, to-be-fixed

r13325 changes reverted, to-be-fixed

r13326 changes reverted, to-be-fixed

r13327 changes reverted, to-be-fixed

r13329 changes reverted, to-be-fixed

r13330 changes reverted, to-be-fixed

r13331 changes reverted, but reimplemented already in r13502

I have fixed this issue (by "re-merging" the respective commits) on a local checkout of source:/trunk@13503 using:

merge from:      trunk

revisions range: 13287,13303,13322-13327,13329-13330

merge into:      trunk

ignore ancestry: true

merge conflict caused by r13322 in:

  * Gemfile

    - caused by additional change already in trunk [removal of rake gem requirement] --> solved locally.

 I have wrapped up these changes into a single patch file (svn diff >

rm18174-reintegrate_commits_on_trunk_reverted_by_r13482_merge-trunk_r13503.patch) to-be-applied onto source:/trunk. I'll attach it here.

toshio harita: I've removed you as the assignee. It doesn't matter who actually commits this patch...

I'll add some committers as watchers though. This to make sure it gets picked up...

Kind regards,

Mischa.

#4 - 2014-10-24 20:46 - Jean-Philippe Lang

- Status changed from Confirmed to Closed

- Assignee set to Jean-Philippe Lang

- Resolution set to Fixed

Sorry for the mess, the pacth is committed in r13504. Thank you Misha for this work!

#5 - 2014-10-24 20:48 - Jean-Philippe Lang

- Related to Feature #14534: Upgrade to Rails 4.2 added

#6 - 2014-10-25 07:31 - Mischa The Evil

Jean-Philippe Lang wrote:

Sorry for the mess, the pacth is committed in r13504. Thank you Misha for this work!

 Good to see this is fixed now. Glad to be of help to the project.
